<?php

function strip_lfcr($string) {
  $string=str_replace("\r\n","\n",$string);
  $string=trim(ereg_replace("\n\n","\n",$string));
  return $string;
}


function gethostbyaddr_disk($ip) {  
  global $g_dns,$g_dnspos,$g_dnsneg;

  $t = time();
  $ip=trim($ip);
  $host="";

  
  if (PRG_DISKCACHE && $g_dns) {
    $cache_entry=array();
    if (file_exists(PRG_DISKCACHEDIR.PRG_SHORTNAME."_dnscache")) {
      $fd=@fopen(PRG_DISKCACHEDIR.PRG_SHORTNAME."_dnscache","r");
      if ($fd) {
        while (!feof ($fd)) {
          $buffer = trim(fgets($fd, 4096));
	  if ($buffer) {
	    $line=split(";",trim($buffer));
	    if ($line[0] > $t)
	      $cache_entry[$line[1]]=$line;
	  }
        }
        fclose ($fd);
      }
    }
    if (isset($cache_entry[$ip]))
      $host=$cache_entry[$ip][2];
    if ($host=="") {
      $host=gethostbyaddr($ip);
      if ($ip!=$host) {
	if ($g_dnspos>0)
    	  $cache_entry[$ip]=array($t+($g_dnspos*60),$ip,$host);
      }
      else {
	if ($g_dnsneg>0)
          $cache_entry[$ip]=array($t+($g_dnsneg*60),$ip,$ip);
      }
      $fd=@fopen(PRG_DISKCACHEDIR.PRG_SHORTNAME."_dnscache","w");
      if ($fd) {
        reset($cache_entry);
        foreach($cache_entry as $c) {
          fputs($fd,implode(";",$c)."\n");
        }
        fclose ($fd);
      }
    }
    return $host;
  }
  else
    return gethostbyaddr($ip);
}


function gethostbyaddr_db($ip) {
  if (!defined("PRG_DBHOSTS"))
    return gethostbyaddr_disk($ip);
  $host="";
  $res=SQL_query("SELECT name FROM `".PRG_DBHOSTS."` WHERE ip like \"".SQL_escape($ip)."\"");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      $host=$row[0];
    SQL_free_result($res);
  }
  if ($host)
    return $host;
  else
    return gethostbyaddr_disk($ip);
}

function gethostbyaddr_cache($ip,$size="",$align="center") {
  global $dns_cache_entry;
    
  if (is_numeric($ip)) {
    $ipa=num2ip($ip);   
    if (is_ip($ipa))
      $ip=$ipa;
  } 
  if (is_ip($ip)&&($ip!="255.255.255.255")) {
    if (isset($dns_cache_entry[$ip]) && $dns_cache_entry[$ip]!="")
      $host=$dns_cache_entry[$ip];
    else {
      $host=gethostbyaddr_db($ip);
      $host=strtolower($host);
      $dns_cache_entry[$ip]=$host;
    }
    
    if ($size) {
      $length=strlen($host);
      if ($length > $size) {
        if ($align=="left")
	  $host=substr($host,0,$size-2)."..";
	else
	if ($align=="right")
	  $host="..".substr($host,$length,-($size-2));
        else {
          $rlen=round($size*0.7); # set right length to 70% of maximal size
          $right=substr($host,$length-$rlen,255);
          $point=strpos($right,"."); # and find first .
          if ($point > 0)
            $right=substr($right,$point,255); #right part is behind this separator
          $rlen=strlen($right);
          $llen=$size-$rlen-2; #decrease -2, two points to signaling long name ...
          if ($llen>0)
            $left=substr($host,0,$llen); #add left part
          $host=$left."..".$right;
	}
      }
    }
  }
  else
    $host=$ip;
  return $host;
}

function gethostbyname_db($name) {
  if (!defined("PRG_DBHOSTS"))
    return gethostbyname($name);
  $ip="";
  $res=SQL_query("SELECT ip FROM `".PRG_DBHOSTS."` WHERE name like \"".SQL_escape($name)."\"");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      $ip=$row[0];
    SQL_free_result($res);
  }
  if ($ip)
    return $ip;
  else
    return gethostbyname($name);
}

function gethostbyname_cache($name) {
  global $dns_cache_entry_ip;
    
  if (isset($dns_cache_entry_ip[$name]) && $dns_cache_entry_ip[$name]!="")
      $ip=$dns_cache_entry_ip[$name];
  else {
      $ip=gethostbyname_db($name);
      $dns_cache_entry_ip[$name]=$ip;
  }
  return $ip;
}


function str_strip($str,$len="60") {
  if (strlen($str) > $len) {
    return substr($str,0,$len)." ...";
  }
  return $str;
}


function str_add($delimiter) {
  $num=func_num_args();
  $arg=func_get_args();
  
  for ($i=1;$i<$num;$i++) {
    if ($arg[$i]) {
      if ($str)
        $str.=$delimiter.$arg[$i];
      else
        $str=$arg[$i];
    }
  }
  return $str;
}


function check_command($cmds) {
  global $command;
  $arr=func_get_args();
  if (!in_array($command,$arr))
    $command="";
}


function req_var() {
  $a=func_get_args();
  $j=func_num_args();
  
  for ($i=0;$i<$j;$i+=2) {
    if (!$a[$i]) {
      MsgError(x("Variable %s is required !"),$a[$i+1]);
      return false;
    }
  }
  return true;
}



function var_string(&$err,$var,$txt,$default="",$length="0",$strip="1") {
  global $$var;
  
  if ($$var=="")
    $$var=$default;
  $tmp=$$var;
  if ($tmp=="") {
    if (!$err) MsgError(x("Item %s is required!"),$txt);
    $err=1;
    return false;
  }
  if ($length && strlen($tmp)>$length) {
    if ($strip) {
      $$var=substr($tmp,0,$length);
      if (!$err) MsgInfo(x("Item %s truncated (max. length is %s)..."),$txt,$length);
    }
    else {
      if (!$err) MsgError(x("Item %s is too long (max. length is %s)..."),$txt,$length);
      $err=1;
      return false;
    }
  }
  return true;
}



function var_number(&$err,$var,$txt,$default="",$min="0",$max="0") {
  global $$var;
  
  if ($$var=="")
    $$var=$default;
  if ($$var=="")
    $$var=0;

  $tmp=$$var;

  if (!is_numeric($tmp)) {
    if (!$err) MsgError(x("Item %s isn't number !"),$txt);
    $err=1;
    return false;
  }
  if ($min && $tmp<$min) {
    if (!$err) MsgError(x("Item %s must be number greater than %s..."),$txt,$min);
    $err=1;
    return false;  
  }
  if ($max && $tmp>$max) {
    if (!$err) MsgError(x("Item %s must be number less than %s..."),$txt,$max);
    $err=1;
    return false;  
  }
  return true;
}


function var_ip(&$err,$var,$txt) {
  global $$var;
  
  $tmp=$$var;

  if (!is_ip($tmp)) {
    if (!$err) MsgError(x("Item %s isn't ip address !"),$txt);
    $err=1;
    return false;
  }
  return true;
}

function var_special(&$err,$var,$txt) {
  if ($var) {
    if (!$err) MsgError($txt);
    $err=1;
    return false;
  }
  return true;
}




function is_ip($ip) {
  if (!is_string($ip))
    return 0;
  $ip_long = ip2long($ip);
  $ip_reverse = long2ip($ip_long);
  if($ip==$ip_reverse)
    return 1;
  return 0;
}

function is_ipname($ipname) {
  $ret=is_ip($ipname);
  if (!$ret)
    $ret=is_ip(gethostbyname_cache($ipname));
  return $ret;
}


function is_proto($protoname) {
  if (is_numeric($protoname) && $protoname>=0 && $protoname<=255)
    return true;
  if (!is_numeric($protoname)) {
    $pr=getprotobyname($protoname);
    if ($pr && $pr!=$proto)
      return true;
  }
  return false;
}


function is_port($portname,$proto="") {
  $portm=strpos($portname,"/");
  if ($portm > 0) {
    $proto=substr($portname,0,$portm);
    $portname=substr($portname,$portm+1);
  }
  if (is_numeric($portname) && $portname>=0 && $portname<=65535)
    return true;
  if (is_numeric($proto))
    $proto=num2proto($proto);
  if ($proto=="")
    $proto="tcp";
  $p=getservbyname($portname,$proto);
  if ($p && $p!=$portname)
    return true;
  return false;
}

function ip2num($addr) {
  if (!$addr) return "";
  if (!is_ip($addr))
    $addr=gethostbyname_cache($addr);
  if (is_ip($addr))
    return sprintf("%u",ip2long($addr));
  return "";
}



function num2ip($num) {
  if (!is_numeric($num)) return "";
  settype($num, "double");
  return long2ip($num);
}



function proto2num($proto) {
  if (is_numeric($proto))
    return $proto;
     
  $pr = getprotobyname($proto);
  if ($pr && $pr!=$proto)
    return $pr;
  return ""; /* error */       
}

function num2proto($num) {
  if ($num=="") return "";
  $name=getprotobynumber($num);
  if ($name=="")
    return $num;
  return $name;
}

function tos2num($tos) {
  if (strlen($tos)==0)
    return false;
  if (is_numeric($tos)) {
    if ($tos<0 || $tos>255)
      return false;
    return $tos;
  }
  $tos=strtoupper($tos);
  switch ($tos) {
    case "BE":  return 0;
    case "AF11": return 40;
    case "AF12": return 48;
    case "AF13": return 56;
    case "AF21": return 72;
    case "AF22": return 80;
    case "AF23": return 88;
    case "AF31": return 104;
    case "AF32": return 112;
    case "AF33": return 120;
    case "AF41": return 136;
    case "AF42": return 144;
    case "AF43": return 152;
    case "CS1": return 32;
    case "CS2": return 64;
    case "CS3": return 96;
    case "CS4": return 128;
    case "CS5": return 160;
    case "NC1":
    case "CS6": return 192;
    case "NC2":
    case "CS7": return 224;
    case "EF": return 184;
  }
  
  $tos_num=0;
  $p=0;
  $d=0;
  $t=0;
  $r=0;
  for ($i=0;$i<strlen($tos);$i++) {
    $char=$tos[$i];
    if (!$p && $char>='0' && $char<='7') { $p=1; $tos_num+=($char<<5); }
    elseif ($char=='P')  { /* ignore P char, it must be used when do you want do only precedence e.g. P3 */ } 
    elseif (!$d && $char=='D') { $d=1; $tos_num+=16; }
    elseif (!$t && $char=='T') { $t=1; $tos_num+=8; }
    elseif (!$r && $char=='R') { $r=1; $tos_num+=4; }
    else return false;
  }
  return $tos_num;
}

function port2num($port,$proto="tcp") {  
  if (is_numeric($port))
    return $port;
  if ($proto=="")
    $proto="tcp";
  $portm=strpos($port,"/");
  if ($portm > 0) {
    $proto=substr($port,0,$portm);
    $port=substr($port,$portm+1,255);
  }
  if (is_numeric($proto))
    $proto=num2proto($proto);

  if (is_numeric($port))
    return $port;
    
  $p=getservbyname($port,$proto);
  if ($p && $p!=$port)
    return $p;
  return ""; /* error */
}



function num2port($port,$proto="") {
  
  if (!is_numeric($proto)) {
    $sproto=$proto;
    $proto=proto2num($proto);
  }
  else
    $sproto=num2proto($proto);
  
  
  if ($proto==1) { #ICMP
    $icmptype=round($port/256);
    $icmpsubtype=$port%256;
    $port=$icmptype;
    
    $sport="";
    switch ($icmptype) {
      case 0: $sport=x("echo pong"); break;
      case 3:
        switch ($icmpsubtype) {
	  case 0: $sport=x("net unreachable"); break;
	  case 1: $sport=x("host unreachable"); break;
	  case 2: $sport=x("proto unreachable"); break;
	  case 3: $sport=x("port unreachable"); break;
	  case 4: $sport=x("fragment needed"); break;
	  case 5: $sport=x("sourceroute failed"); break;
	  case 6: $sport=x("net unknown"); break;
	  case 7: $sport=x("host unknown"); break;
	  case 8: $sport=x("host isolated"); break;
	  case 9: $sport=x("net ANO"); break;
	  case 10: $sport=x("host ANO"); break;
	  case 11: $sport=x("net unreach TOS"); break;
	  case 12: $sport=x("host unreach TOS"); break;
	  case 13: $sport=x("pkt filtered"); break;
	  case 14: $sport=x("prec violation"); break;
	  case 15: $sport=x("prec cutoff"); break;
	}
	break;
      case 4: $sport=x("source quench"); break;
      case 5:
        switch ($icmpsubtype) {
	  case 0: $sport=x("redir net"); break;
	  case 1: $sport=x("redir host"); break;
	  case 2: $sport=x("redir netTOS"); break;
	  case 3: $sport=x("redir hostTOS"); break;
	}
	break;      
      case 8: $sport=x("echo ping"); break;
      case 11: $sport=x("ttl exceeded"); break;
      case 12: $sport=x("parameter problem"); break;
      case 13: $sport=x("timestamp RQ"); break;
      case 14: $sport=x("timestamp RP"); break;
      case 15: $sport=x("info RQ"); break;
      case 16: $sport=x("info RP"); break;
      case 17: $sport=x("address RQ"); break;
      case 18: $sport=x("address RP"); break;
    } /* switch */
    return ($sport)?$sport:$port;
  }
 
  $name="";
  if (($proto)&&($sproto))
    $name=getservbyport($port,$sproto);
  if ($name)
    return $name;
  return $port;
}

function num2date($date) {
  if ($date=="") return "";
  if (!is_numeric($date)) return $date;
  return date("d/m/Y H:i:s",$date);
}

function long2uptime($uptime) {
  $d = (integer) ($uptime / 86400);
  $h = (integer) (($uptime % 86400) / 3600);
  $m = (integer) (($uptime % 3600) / 60);
  $s = (integer) ($uptime % 60);
  return $d." days ".$h."h ".$m."m ".$s."s";
}

function long2time($row) {
  return date("Y/m/d H:i:s",$row);
}


function my_snmpwalk_keys($host,$community,$oid,$timeout="4000000",$retries="2") {  
  global $g_community;

  $b=array();
  if (!function_exists('snmprealwalk'))
    return $b;
  if (!$community)
    $community=$g_community;
  if (!$community)
    $community="public";
  $a = @snmprealwalk($host,$community,$oid,$timeout,$retries);
  if (is_array($a)) {
    while (list($key,$line) = each($a)) {
      $line=eregi_replace("string:","",$line);
      $line=eregi_replace("integer:","",$line);
      $line=eregi_replace("gauge32:","",$line);
      $line=eregi_replace("oid:","",$line);
      $line=eregi_replace("timeticks:","",$line);      
      $line=eregi_replace("counter32:","",$line);
      $line=eregi_replace("ipaddress:","",$line);
      $line=ereg_replace(".*=","",$line);
      $line=ereg_replace("\(.*\)","",$line);
      $line=trim($line);      
      $b[$key]=$line;
    }
  }
  reset($b);
  return $b;
}

function my_snmpwalk($host,$community,$oid,$timeout="4000000",$retries="2") {
  $a=my_snmpwalk_keys($host,$community,$oid,$timeout,$retries);
  $b=array();
  reset($a);
  foreach($a as $item)
    $b[]=$item;
  reset($b);
  return $b;
}


function my_snmpget($host,$community,$oid,$timeout="1000000",$retries="2") {
  global $g_community;

  if (!function_exists('snmpget'))
    return '';
  if (!$community)
    $community=$g_community;
  if (!$community)
    $community="public";
  $line = @snmpget($host,$community,$oid,$timeout,$retries);
  $line=eregi_replace("string:","",$line);
  $line=eregi_replace("integer:","",$line);
  $line=eregi_replace("gauge32:","",$line);
  $line=eregi_replace("oid:","",$line);
  $line=eregi_replace("timeticks:","",$line);      
  $line=eregi_replace("counter32:","",$line);
  $line=eregi_replace("ipaddress:","",$line);
  $line=ereg_replace(".*=","",$line);
  $line=ereg_replace("\(.*\)","",$line);
  $line=trim($line);      
  return $line;
}


function show_ping($ip_address) {
  $tmp = EscapeShellCmd($ip_address);    
  echo "<pre>\n";
  passthru("ping -c3 -n $tmp 2>&1");
  echo "</pre>\n\n";
}

function show_snmp($ip_address,$community) {
  $sys_descr=@my_snmpwalk($ip_address,$community, ".1.3.6.1.2.1.1.1");
  $sys_name=@my_snmpwalk($ip_address,$community, ".1.3.6.1.2.1.1.5");
  if ((is_array($sys_descr)&&count($sys_descr)>0)||(is_array($sys_name)&&count($sys_name)>0)) {
    $lines="";
    foreach($sys_name as $line)
      $lines.=$line."<br/><br/>\n";
    foreach($sys_descr as $line)
      $lines.=$line."<br/>\n";
    $lines.="<br/><b>".x("SNMP is correctly configured...")."</b>";
    Msg(MSGDLG_INFO,x("SNMP Check")." (".$ip_address.")",$lines);
  }
  else
    MsgError(x("Error while retrieving SNMP stats. Check IP address and community string."));
}


function check_id($table,$id,$accept_zero="1") {
  $ret=-1;
  if ($accept_zero && $id==0)
    return 0;
  $res=SQL_query("SELECT * FROM $table WHERE id='".SQL_escape($id)."'");
  if ($res) {
    if (($row=SQL_fetch_array($res)))
      $ret=0;
    SQL_free_result($res);
  }
  return $ret;
}


function make_where($where,$variable,$logic="and",$exact=0,$op="=") {
  global $$variable;
  
  $value=$$variable;
  if ($value || $exact) {
    if ($where=="")
      $where="WHERE $variable$op'".SQL_escape($value)."'";
    else
      $where.=" ".$logic." $variable$op'".SQL_escape($value)."'";
  }
  return $where;
}



/* get min unixtime for given hour, patch for DST */
function GetMinUnixtime($y,$m,$d,$h) {
  $unixt=mktime($h,0,0,$m,$d,$y);
  $unixok=$unixt;
  while (1) {
    $ta=localtime($unixt,1);
    if ($ta["tm_hour"]==$h && $ta["tm_mday"]==$d && $ta["tm_mon"]+1==$m && $ta["tm_year"]==$y+100) {
      $unixok=$unixt;
      $unixt-=60;
    }
    else
      break;
  }
  return $unixok;
}


/* get max unixtime for given hour, patch for DST */
function GetMaxUnixtime($y,$m,$d,$h) {
  $unixt=mktime($h,59,59,$m,$d,$y);
  $unixok=$unixt;
  while (1) {
    $ta=localtime($unixt,1);
    if ($ta["tm_hour"]==$h && $ta["tm_mday"]==$d && $ta["tm_mon"]+1==$m && $ta["tm_year"]==$y+100) {
      $unixok=$unixt;
      $unixt+=60;
    }
    else
      break;
  }
  return $unixok;
}


/* get max unixtime for given hour, patch for DST (month modification)*/
function GetMaxUnixtime_month($y,$m) {
  $unixt=mktime(0,0,0,$m+1,0,$y);
  while (1) {
    $ta=localtime($unixt,1);
    if ($ta["tm_mon"]+1==$m && $ta["tm_year"]==$y+100) {
      $unixok=$unixt;
      $unixt+=60;
    }
    else
      break;
  }
  return $unixok;
}

function myround($val,$precision=0,$zeropad=0) {
  $ret=round($val,$precision);
  if ($zeropad && $precision && !strstr($ret,'.') && !strstr($ret,',')) {
    $ret.='.';
    for ($i=0;$i<$precision;$i++)
      $ret.='0';
  }
  return $ret;
}

function number2human($number,$binary="0",$digits=1,$zeropad=0) {
  $sign="";
  if ($number<0)
    $sign="-";
  $number=abs($number);
  if ($binary="up") {
    if ($number >= 1099511627776)
      return $sign.myround($number/1099511627776,$digits,$zeropad)."T";
    if ($number >= 1073741824)
      return $sign.myround($number/1073741824,$digits,$zeropad)."G";
    if ($number >= 1048576)
      return $sign.myround($number/1048576,$digits,$zeropad)."M";
    if ($number >= 1024)
      return $sign.myround($number/1024,$digits,$zeropad)."K";
    else
      return $sign.myround($number,$digits,$zeropad);
  }
  elseif ($binary) {
    if ($number >= 1099511627776)
      return $sign.myround($number/1099511627776,$digits,$zeropad)."t";
    if ($number >= 1073741824)
      return $sign.myround($number/1073741824,$digits,$zeropad)."g";
    if ($number >= 1048576)
      return $sign.myround($number/1048576,$digits,$zeropad)."m";
    if ($number >= 1024)
      return $sign.myround($number/1024,$digits,$zeropad)."k";
    else
      return $sign.myround($number,$digits,$zeropad);
  }
  else {
    if ($number >= 1000000000000)
      return $sign.myround($number/1000000000000,$digits,$zeropad)."T";
    if ($number >= 1000000000)
      return $sign.myround($number/1000000000,$digits,$zeropad)."G";
    if ($number >= 1000000)
      return $sign.myround($number/1000000,$digits,$zeropad)."M";
    if ($number >= 1000)
      return $sign.myround($number/1000,$digits,$zeropad)."K";
    else
      return $sign.myround($number,$digits,$zeropad);
  }
}


function eregi_replace_repeat($match,$replace,$string) {
  while (eregi($match,$string))
    $string=eregi_replace($match,$replace,$string);
  return $string;
}



function load_styles() {
  $list_style[""]=x("*** auto ***");
  $handle=opendir(PRG_PATH.PRG_STYLEDIR);
  if ($handle) {
    while ($file = readdir($handle)) {
      if (is_file(PRG_PATH.PRG_STYLEDIR.$file) && !eregi("print.css",$file))
        $list_style[$file]=eregi_replace("\..*","",$file);
    }
    closedir($handle);
  }
  return $list_style;
}



function RequireRights($reqs) {
  global $u_rights;

  if (strstr($u_rights,"admin"))
    return;

  $lreq=explode(",",$reqs);
  foreach ($lreq as $req) {
    if (strstr($u_rights,$req))
      return;
  }
  MsgFatal(x("You haven't rights to view this page ..."));
}


function CheckRights($reqs) {
  global $u_rights;

  if (strstr($u_rights,"admin"))
    return 1;
  $lreq=explode(",",$reqs);
  foreach ($lreq as $req) {
    if (strstr($u_rights,$req))
      return 1;
  }
  return 0;
}

function myfputcsv($handle, $row, $fd=',', $quot='"') {
  $str='';
  foreach ($row as $cell) {
    $cell=str_replace(array($quot,"\n"),array($quot.$quot,''),$cell);
    if (strchr($cell, $fd)!==FALSE || strchr($cell, $quot)!==FALSE)
      $str.=$quot.$cell.$quot.$fd;
    else
      $str.=$cell.$fd;
  }
  if ($handle)
    fputs($handle, substr($str, 0, -1)."\n");
  return strlen($str);
}




function mail_test_write($handle,$wr) {
  usleep(50000);
  fputs($handle,$wr);
  return mail_test_read($handle);
}

function mail_test_read($handle) {
  $text="";
  $s=0;
  if (function_exists('stream_set_blocking'))
    stream_set_blocking($handle, false);
  else
    set_socket_blocking($handle, false);
  do {
    $out=fgets($handle,2500);
    if (eregi("^[0-9]+\ ",$out)) {
	$text.=$out;
	break;
    }
    elseif ($out) {
	$text.=$out;
	$s=0;
    }
    else {
    	usleep(10000);
        $s++;
    }
    if($s==500)
        break;
  } while(1);
  if (function_exists('stream_set_blocking'))
    stream_set_blocking($handle, true);
  else
    set_socket_blocking($handle, true);
  return $text;
}


function mail_test($addr,$smtp_check="0") {
  $valid=0;

  if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$addr))
    return 0;

  if (!$smtp_check)
    return 1; /* valid email address format */

  $server=$_SERVER['SERVER_NAME'];
  if (!$server)
    $server="www.mail.com";

  $ar=explode("@",$addr);
  $username=$ar[0];
  $address=$ar[1];
  getmxrr($address,$mxhosts);
  if (count($mxhosts)==0)
    $mxhosts[]=$address;
  foreach ($mxhosts as $host) {
    $ip=gethostbyname($host);
    
    if (is_ip($ip)) {
      if (($handle=@fsockopen($ip,25))) {        
	mail_test_read($handle);
        mail_test_write($handle,"HELO $server\r\n");
	mail_test_write($handle,"MAIL FROM:<checkmailbot@$server>\r\n");
	$x=mail_test_write($handle,"RCPT TO:<$addr>\r\n");
	$x=eregi_replace("\ .*","",$x);
	if ($x==250 || $x==450)
	  $valid=1;
	mail_test_write($handle,"QUIT\r\n");
        fclose($handle);
	if ($valid)
	  return 1;
      }
    }
  }
  return 0; /* not valid smtp mail to */
}

function mail_head($boundary,$from) {
  global $mail_headers;
  $mail_headers = "";
  if ($from)
    $mail_headers .= "From: $from\n";
  $mail_headers .= "MIME-Version: 1.0\n";
  $mail_headers .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\n";
}


function mail_init() {
  global $mail_message;
  $mail_message="This is a multi-part message in MIME format.\n\n";
  return '----='.md5(uniqid(rand()));
}

function mail_text($boundary,$text) {
  global $mail_message;

  $mail_message.= "--$boundary\n";
  $mail_message.= "Content-Type: text/plain; format=flowed; charset=\"iso-8859-1\"\n";
  $mail_message.= "Content-Transfer-Encoding: 7bit\n\n";

  $mail_message.= $text."\n\n";
}


function mail_attcs($boundary,$string,$name,$content_type) {
  global $mail_message;

  if ($string) {
    $mail_message.= "--$boundary\n";
    $mail_message.= "Content-Type: $content_type; name=\"$name\"\n";
    $mail_message.= "Content-Transfer-Encoding: base64\n";
    $mail_message.= "Content-Disposition: attachment; filename=\"$name\"\n\n";
    $mail_message.= chunk_split(base64_encode($string)) ."\n";
  }
}


function mail_attc($boundary,$file,$name,$content_type) {
  global $mail_message;

  if (file_exists($file)) {
    $mail_message.= "--$boundary\n";
    $mail_message.= "Content-Type: $content_type; name=\"$name\"\n";
    $mail_message.= "Content-Transfer-Encoding: base64\n";
    $mail_message.= "Content-Disposition: attachment; filename=\"$name\"\n\n";
    $content="";
    $fp = fopen($file, 'r');
    do {
      $data = fread($fp, 8192);
      if (strlen($data) == 0) break;
      $content .= $data;
    } while (true);
    fclose($fp);
    $mail_message.= chunk_split(base64_encode($content)) ."\n";
  }
}



function mail_finish($boundary) {
  global $mail_message;

  $mail_message.= "--$boundary--\n";
}


function demo_die() {
  if (defined('PRG_DEMO')) {
    MsgWarn(x("This page isn't available in live demo version."));
    die();
  }
}

function demo_cmd($cmd,$set="",$die="") {
  global $command;
  if (defined('PRG_DEMO')) {
    if ($command==$cmd) {
      MsgWarn(x("This function isn't available in live demo version."));
      $command=$set;
      if ($die)
	die();
    }
  }
}

function get_uptime($t) {
  $d = (integer) ($t / 86400);
  $h = (integer) (($t % 86400) / 3600);
  $m = (integer) (($t % 3600) / 60);
  $s = (integer) ($t % 60);
  if ($d)
    return x("%d days, %d hours, %d minutes and %d seconds",$d,$h,$m,$s);
  if ($h)
    return x("%d hours, %d minutes and %d seconds",$h,$m,$s);
  return x("%d minutes and %d seconds",$m,$s);
  
}

function show_value($val,$short=0) {
  $text="";
  if ($val>100000) {
    if ($short)
      $text=number2human($val);
    else
      $text=$val."&nbsp;(".number2human($val).")";
  }
  else
    $text=$val;
  return $text;
}


function show_errorvalue($val,$short=0) {
  $text=show_value($val,$short);

  if ($val>0)
    return "<font color=\"#FF0000\"><b>$text</b></font>";
  return $text;
}

?>