<?php


set_default('report_body_head',x('Dear user, the software detected a security incident.')."\n");
set_default('report_body_tail',x('Network security TEAM'));
set_default('report_subject',x('Network incident'),1);
set_default('clean_new','31',1);
set_default('clean_other','91',1);
set_default('color_i_cri','FF0000',1);
set_default('color_i_urg','FF4000',1);
set_default('color_i_imp','FFA000',1);
set_default('color_i_war','FFD000',1);
set_default('color_i_inf','A0A000',1);

set_default('color_e_cri','FF0080',1);
set_default('color_e_urg','A000FF',1);
set_default('color_e_imp','4040FF',1);
set_default('color_e_war','8080FF',1);
set_default('color_e_inf','C0C0FF',1);


$list_time[1]=x("Current hour");
$list_time[2]=x("Last 3 hours");
$list_time[3]=x("Last 24 hours");
$list_time[4]=x("Last 3 days");
$list_time[5]=x("Last 7 days");
$list_time[6]=x("Last 14 days");
$list_time[7]=x("Last 31 days");
$list_time[8]=x("All");

$list_sev[5]=x("Critical");
$list_sev[4]=x("Urgent");
$list_sev[3]=x("Important");
$list_sev[2]=x("Warning");
$list_sev[1]=x("Informational");

$list_int[0]=x("Any network");
$list_int[1]=x("Internal network");
$list_int[2]=x("External network");

$list_state['new']=x("New");
$list_state['solving']=x("Solving");
$list_state['resolved']=x("Resolved");
$list_state['archive']=x("Archived");
$list_state['any']=x("Any");


function set_default($var,$value,$nonempty="0") {
  global $$var;
  if (!isset($$var))
    $$var=$value;
  elseif ($nonempty && $$var=="")
    $$var=$value;  
}

function anomaly_load_options() {
  global $report_body_head,$report_body_tail,$report_subject,$report_i_email,$report_e_email;
  global $clean_new,$clean_other;
  global $color_i_cri,$color_i_urg,$color_i_imp,$color_i_war,$color_i_inf;
  global $color_e_cri,$color_e_urg,$color_e_imp,$color_e_war,$color_e_inf;
  
  $res=SQL_query("SELECT opt,v1 FROM x_na_opt");
  if ($res) {
    while (($row=SQL_fetch_row($res))) {
      switch ($row[0]) {
	  case "report_body_head": $report_body_head=$row[1]; break;
	  case "report_body_tail": $report_body_tail=$row[1]; break;
	  case "report_subject": $report_subject=$row[1]; break;
	  case "report_i_email": $report_i_email=$row[1]; break;
	  case "report_e_email": $report_e_email=$row[1]; break;
	  case "clean_new": $clean_new=$row[1]; break;
	  case "clean_other": $clean_other=$row[1]; break;
	  case "color_i_cri": $color_i_cri=$row[1]; break;
	  case "color_i_urg": $color_i_urg=$row[1]; break;
	  case "color_i_imp": $color_i_imp=$row[1]; break;
	  case "color_i_war": $color_i_war=$row[1]; break;
	  case "color_i_inf": $color_i_inf=$row[1]; break;
	  case "color_e_cri": $color_e_cri=$row[1]; break;
	  case "color_e_urg": $color_e_urg=$row[1]; break;
	  case "color_e_imp": $color_e_imp=$row[1]; break;
	  case "color_e_war": $color_e_war=$row[1]; break;
	  case "color_e_inf": $color_e_inf=$row[1]; break;
      }
    }
    SQL_free_result($res);
  }
}

function TAnomaly($sev,$int) {
  global $color_i_cri,$color_i_urg,$color_i_imp,$color_i_war,$color_i_inf;
  global $color_e_cri,$color_e_urg,$color_e_imp,$color_e_war,$color_e_inf;
  global $linecounter,$u_java;
  
  if ($int==1) {
    switch ($sev) {
      case 5: $color=$color_i_cri; break;
      case 4: $color=$color_i_urg; break;
      case 3: $color=$color_i_imp; break;
      case 2: $color=$color_i_war; break;
      case 1: $color=$color_i_inf; break;
    }
  }
  else {
    switch ($sev) {
      case 5: $color=$color_e_cri; break;
      case 4: $color=$color_e_urg; break;
      case 3: $color=$color_e_imp; break;
      case 2: $color=$color_e_war; break;
      case 1: $color=$color_e_inf; break;
    }
  }
  $color_r=hexdec(substr($color,0,2));
  $color_g=hexdec(substr($color,2,2));
  $color_b=hexdec(substr($color,4,2));
  $color1=sprintf("%02x%02x%02x",$color_r|0x0F,$color_g|0x0F,$color_b|0x0F);
  $color2=sprintf("%02x%02x%02x",$color_r&0xF0,$color_g&0xF0,$color_b&0xF0);
  
  $param="";  
  if ($linecounter%2) {
    if ($u_java)
      $param.=" onmouseover=\"javascript: this.className='linejava'\" onmouseout=\"javascript: this.className=''\"";
    $param.=" bgcolor=\"#$color1\"";
  }
  else {
    if ($u_java)
      $param.=" onmouseover=\"javascript: this.className='linejava'\" onmouseout=\"javascript: this.className=''\"";
    $param.=" bgcolor=\"#$color2\"";
  }
  $linecounter++;
  TNext($param);
}

function get_incident_detail($id,$sep="<br/>") {
  global $na_mod;
  $ret="";
  $v=SQL_escape($id);
  $res=SQL_query("SELECT count(*) FROM x_na_an WHERE id_inc='$v'");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      if ($row[0]<2)
        $ret=$sep.$row[0]." ".x("anomaly");
      else
        $ret=$sep.$row[0]." ".x("anomalies");
    SQL_free_result($res);
  }

  $res=SQL_query("SELECT na,count(distinct nas) FROM x_na_al WHERE id_inc='$v' GROUP BY na LIMIT 10");
  if ($res) {
    $ret.="$sep";
    $str="";
    while ($row=SQL_fetch_row($res)) {
      if (isset($na_mod[$row[0]]) && $na_mod[$row[0]] && $na_mod[$row[0]]['name']) {
        if ($str) $str.=", ";
	if ($row[1]>1)
          $str.=$row[1]." ".x("various")." ".$na_mod[$row[0]]['name'];
	else
          $str.=$na_mod[$row[0]]['name'];
      }
    }
    SQL_free_result($res);
    $str=wordwrap(str_strip($str,90),30,$sep);
    $ret.=$str;
  }
  return $ret;
}

function get_alert_detail($id,$sep="<br/>") {
  global $na_mod;
  $ret="";
  $v=SQL_escape($id);
  $res=SQL_query("SELECT count(*) FROM x_na_an WHERE id_al='$v'");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      if ($row[0]<2)
        $ret=$sep.$row[0]." ".x("anomaly");
      else
        $ret=$sep.$row[0]." ".x("anomalies");
    SQL_free_result($res);
  }
  return $ret;
}

function get_length($time) {
  $day=floor($time/86400);
  $time-=($day*86400);
  $hour=floor($time/3600);
  $time-=($hour*3600);
  $min=ceil($time/60);
  
  if ($day>=2)
    $t_day=x("days");
  else
    $t_day=x("day");

  if ($hour>=2)
    $t_hour=x("hours");
  else
    $t_hour=x("hour");
    
  if ($min>=2)
    $t_min=x("minutes");
  else
    $t_min=x("minute");
    
  if ($day>=1)
    return floor($day)." ".$t_day." ".round($hour,2)." ".$t_hour;
  if ($hour>=1)
    return floor($hour)." ".$t_hour." ".$min." ".$t_min;
  return $min." ".$t_min;
}


function get_orderlink($url,$name) {
  global $order,$command;
  $o_a="o_".$name."_a";
  $o_d="o_".$name."_d";
  if ($order==$o_a)
    return $url."?".args(array('command'=>$command,'order'=>$o_d,'offset'=>0));
  else
    return $url."?".args(array('command'=>$command,'order'=>$o_a,'offset'=>0));
}




function get_order($available,$default="") {
  global $order;
  if (is_array($available) && eregi("o_(.*)_([ad])",$order,$regs)) {
    while (list($key,$val)=each($available)) {
      if ($key==$regs[1]) {
        if ($regs[2]=="d")
          return "ORDER BY $val DESC";
	else
          return "ORDER BY $val";	
      }
    }
  }
  if ($default)
    return "ORDER BY $default";
  return "";
}


function list_mod() {
  global $na_mod;
  
  $ret=array();
  if (is_array($na_mod)) {
    reset($na_mod);
    while (list($key,$val)=each($na_mod))
      $ret[$key]=$val['name'];
  }
  return $ret;
}


function format_srcdst($type,$obj,$row) {
  $params="";
  while (list($key,$val) = each($row)) {
    if (!is_numeric($key))
      $params.="$key=$val&";
  }
  switch ($type) {
    case 0: return x("N/A");
    case 1: return ShowLink(xformat_ip(0,$obj),"anomaly_a.php?".$params);
    default: return x("not implemented");
  }
}


function format_srcdstnet($type,$obj,$row) {
  $params="";
  switch ($type) {
    case 0: return x("N/A");
    case 1: return x("network")." ".num2ip($obj);
    default: return x("not implemented");
  }
}

function format_na($na,$nas) {
  global $na_mod;
 
  if ($nas && is_array($na_mod[$na]['nas']))
    return $na_mod[$na]['name']."<br/>".$na_mod[$na]['nas'][$nas];
  return $na_mod[$na]['name'];
}

?>