<?php

require_once(PRG_PATH . 'core/jg/jpgraph.php');
require_once(PRG_PATH . 'core/jg/jpgraph_log.php');
require_once(PRG_PATH . 'core/jg/jpgraph_bar.php');
require_once(PRG_PATH . 'core/jg/jpgraph_line.php');
require_once(PRG_PATH . 'core/jg/jpgraph_radar.php');
require_once(PRG_PATH . 'core/jg/jpgraph_iconplot.php');


function generate_graph($id,$handler,$u_id,$csim_mode="") {
  global $themearr;

$caption = "";
$subcaption="";
$legend_length = 0;
$margin_y = 65;

$w=SQL_escape($u_id);
$res=SQL_query("SELECT graph_x,graph_y,graph_theme FROM x_user WHERE id='$w'");
if ($res) {
  if (($row=SQL_fetch_array($res))) {
    $u_graph_x=$row[0];
    $u_graph_y=$row[1];
    $u_graph_theme=$row[2];
  }    
  SQL_free_result($res);
}

if ($u_graph_x < 640)
   $u_graph_x = 640;
if ($u_graph_x > 1800)
   $u_graph_x = 1800;
if ($u_graph_y < 400)
   $u_graph_y = 400;
if ($u_graph_y > 1600)
  $u_graph_y = 1600;
$graph_aa=0;

$g_grpico_alpha=30;
$res=SQL_query("SELECT name,value FROM x_global");
if ($res) {
  while (($row=SQL_fetch_array($res))) {
      if ($row[0]=="grpico")
        $g_grpico=$row[1];
      if ($row[0]=="grpico_x")
        $g_grpico_x=$row[1];
      if ($row[0]=="grpico_y")
        $g_grpico_y=$row[1];
      if ($row[0]=="grpico_alpha")
        $g_grpico_alpha=$row[1];
      if ($row[0]=="graph_aa")
        $graph_aa=$row[1];
  }
  SQL_free_result($res);
}
 
$v=SQL_escape($id);   
$res=SQL_query("SELECT caption,subcaption,scale,type,axisx,axisy,comment,scaletype,capa from x_graph WHERE id like '$v'");
if ($res) {
  if ($row = SQL_fetch_array($res)) {
     $caption = $row[0];
     $subcaption = $row[1];
     $scale = $row[2];
     $type = $row[3];
     $axisxtitle=$row[4];
     $axisytitle=$row[5];
     $comment=$row[6];
     $scaletype=$row[7];
     $capa=$row[8];
  }
  else
     JpGraphError::Raise(x("Graph ID not found in database ..."));
  SQL_free_result($res);
}
else
  JpGraphError::Raise(x("Error while communicating with database."));


$res=SQL_query("SELECT value from x_graphd WHERE id_graph like '$v' AND axis like 'x' ORDER BY id");
if ($res) {
  if ($row = SQL_fetch_array($res))
    $value_x = explode(",",$row[0]);
  for ($i=0;$i<count($value_x);$i++)
    if ($value_x[$i]=="")
      $value_x[$i]=0;    
  SQL_free_result($res);
}
else
  JpGraphError::Raise(x("Error while communicating with database."));
   

if ($type>=30 && $type<40)
  $graph = new RadarGraph($u_graph_x,$u_graph_y,"");	
else
  $graph = new Graph($u_graph_x,$u_graph_y,"");	


$cnt_y = 0;
$vcnt_y = 0;
$dualy=0;
$res=SQL_query("SELECT legend,value from x_graphd WHERE id_graph like '$v' AND axis like 'y' ORDER BY id");
if ($res) {
  while ($row = SQL_fetch_array($res)) {
      $legend_y[$cnt_y] = $row[0];
      $value_y[$cnt_y] = explode(",",$row[1]);
      $tmp_leg=$graph->img->GetTextWidth($legend_y[$cnt_y]);
      if ($tmp_leg > $legend_length)
        $legend_length=$tmp_leg;
      $value_ysum[$cnt_y]=0;
      for ($i=0;$i<count($value_y[$cnt_y]);$i++) {
        if (intval($value_y[$cnt_y][$i])==0)
	  $value_y[$cnt_y][$i]=intval($value_y[$cnt_y][$i]);
        elseif (intval($value_y[$cnt_y][$i])<0)
	  $dualy=1;
	$value_ysum[$cnt_y]+=abs($value_y[$cnt_y][$i]);
        $value_ytrg[$cnt_y][$i]="javascript:void(0)";
        $value_yalt[$cnt_y][$i]=number2human($value_y[$cnt_y][$i]);
      }
      $vcnt_y=max($vcnt_y,count($value_y[$cnt_y]));
      $cnt_y++;      
  }
  SQL_free_result($res);
}
else
  JpGraphError::Raise(x("Error while communicating with database."));

$grpimg="";
if (isset($g_grpico) && $g_grpico) {
  $res=SQL_query("SELECT data FROM x_imagestore WHERE id='".SQL_escape($g_grpico)."'");
  if ($res) {
    $grpimg=SQL_fetch_row($res);
    $grpimg=base64_decode($grpimg[0]);
    SQL_free_result($res);
  }
}

clear_oldgraph();


if (!$cnt_y)
  JpGraphError::Raise(x("No graph data found in database..."));

if (!isset($themearr[$u_graph_theme])||count($themearr[$u_graph_theme]) < 11)   
  $u_graph_theme="default";
$color=$themearr[$u_graph_theme];
$colornum=count($color);



switch ($type) {
#NON-AGGREGATED BARS
#SPIDER GRAPHS
  case 30:
  case 31:
  case 32: $maxinterval=15; break;
  default: $maxinterval=31; break;
}

$tickinterval=1;
while ($vcnt_y / $tickinterval > $maxinterval)
  $tickinterval++;
  
  
reset($value_x);
switch ($scale) {
  case "h": 
    while (list($key,$val) = each($value_x)) $value_xtxt[$key]=scalehour($val); break;
  case "d": 
    while (list($key,$val) = each($value_x)) $value_xtxt[$key]=scaleday($val); break;
  case "w": 
    while (list($key,$val) = each($value_x)) $value_xtxt[$key]=scaleweek($val); break;
  case "m": 
    while (list($key,$val) = each($value_x)) $value_xtxt[$key]=scalemonth($val); break;
}




/* CREATE GRAPH */
if ($type>=30 && $type<40) {
  if ($scaletype)
    $graph->SetScale("log");
  else
    $graph->SetScale("lin");
}
else {
  if ($scaletype)
    $graph->SetScale("textlog");
  else
    $graph->SetScale("textlin");
}


$graph->SetShadow();
$graph->SetMarginColor("khaki");
if ($dualy)
  $graph->xaxis->SetPos("min");

if ($caption) {
  $graph->title->Set($caption);
  $graph->title->SetFont(FF_FONT2,FS_BOLD);
}
if ($subcaption)
  $graph->subtitle->Set($subcaption);


if ($type>=30 && $type<40) {
  $value_xtxt2=array();
  for ($i=0;$i<count($value_xtxt);$i++)
    if ($i%$tickinterval == 0)
      $value_xtxt2[]=$value_xtxt[$i];
    else
      $value_xtxt2[]="";
  $graph->SetTitles($value_xtxt2);
  $graph->axis->scale->ticks->SetFormatCallback('number2human'); 

  if ($legend_length) 
    $graph->SetCenter(($u_graph_x-$legend_length-20)/(2*$u_graph_x),0.5);
  else
    $graph->SetCenter(0.5,0.5);
  $graph->axis->SetFont(FF_FONT1,FS_BOLD);                                                                                            
  $graph->axis->HideTicks(); 
  $graph->grid->SetLineStyle("dotted");
  $graph->grid->SetColor("darkgray");
  $graph->grid->Show();
}
else {
  $graph->xaxis->SetTickLabels($value_xtxt);
  $graph->xaxis->SetTextTickInterval($tickinterval);
  $graph->xaxis->SetLabelAngle(90);
  $graph->yaxis->SetLabelFormatCallback('number2human'); 

  if ($axisytitle) {
    $graph->yaxis->title->Set($axisytitle);
    $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
    $graph->yaxis->SetTitleMargin(47);
  }

  if ($axisxtitle) {
    $graph->xaxis->title->Set($axisxtitle);
    $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
  }
}



switch ($type) {

#NON-ACCUMULATED SPIDER
  case 32:
    if ($csim_mode)
      return; /* image map is not supported with spider graph */
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new RadarPlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      $dplot[$i]->SetFill(false);
      $dplot[$i]->SetLineWeight(2);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i]);
    }
    for ($i=0;$i<$cnt_y;$i++) 
      $graph->Add($dplot[$cnt_y-$i-1]);
    break;


#ACCUMULATED SPIDER
  case 31:
    if ($csim_mode)
      return; /* image map is not supported with spider graph */
    for ($i=0; $i < $cnt_y; $i++) {
      for ($j=0;($i>0) && $j<$vcnt_y;$j++)
        $value_y[$i][$j]+=$value_y[$i-1][$j];
      $dplot[$i] = new RadarPlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      $dplot[$i]->SetFill(false);
      $dplot[$i]->SetLineWeight(2);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i]);
    }
    for ($i=0;$i<$cnt_y;$i++)
      $graph->Add($dplot[$cnt_y-$i-1]);
    break;


#ACCUMULATED FILLED SPIDER
  case 30:
    if ($csim_mode)
      return; /* image map is not supported with spider graph */
    for ($i=0; $i < $cnt_y; $i++) {
      for ($j=0;($i>0) && $j<$vcnt_y;$j++)
        $value_y[$i][$j]+=$value_y[$i-1][$j];
      $dplot[$i] = new RadarPlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      $dplot[$i]->SetFill(true);
      $dplot[$i]->SetLineWeight(2);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i]);
    }
    for ($i=0;$i<$cnt_y;$i++)
      $graph->Add($dplot[$cnt_y-$i-1]);
    break;




#NON-ACCUMULATED BAR
  case 23:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new BarPlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i]));
      $dplot[$i]->SetCSIMTargets($value_ytrg[$i],$value_yalt[$i]);
      $graph->Add($dplot[$i]);
    }
    break;


#NON-ACCUMULATED FILLED BAR
  case 22:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new BarPlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i]));
      $dplot[$i]->SetCSIMTargets($value_ytrg[$i],$value_yalt[$i]);
      $graph->Add($dplot[$i]);
    }
    break;


#ACCUMULATED BAR
  case 21:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new BarPlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i]));
      $dplot[$i]->SetCSIMTargets($value_ytrg[$i],$value_yalt[$i]);
    }
    $accplot = new AccBarPlot($dplot);
    $graph->Add($accplot);
    break;


#ACCUMULATED FILLED BAR
  case 20:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new BarPlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i]));
      $dplot[$i]->SetCSIMTargets($value_ytrg[$i],$value_yalt[$i]);
    }
    $accplot = new AccBarPlot($dplot);
    $graph->Add($accplot);
    break;


#NON-ACCUMULATED LINE + APR
  case 17:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
      $graph->Add($dplot[$i]);
    }

    $value_ysum=array();
    for ($j=0;$j<$cnt_y;$j++) {
      reset($value_y[$j]);
      while (list($key,$val) = each($value_y[$j]))
        $value_ysum[$key]+=$val;
    }    
    reset($value_ysum);
    for ($i=1;$i<$vcnt_y-1;$i++) {
      $key=key($value_ysum);
      $value_ysum[$key] = (current($value_ysum) + next($value_ysum)) /2;
    }
    $lp = new LinePlot($value_ysum);
    $lp->SetStyle('dashed');
    $lp->SetWeight(2);
    $lp->SetColor('black');
    $graph->Add($lp);
    break;


#NON-ACCUMULATED FILLED LINE + APRX
  case 16:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
      $graph->Add($dplot[$i]);
    }
    
    $value_ysum=array();
    for ($j=0;$j<$cnt_y;$j++) {
      reset($value_y[$j]);
      while (list($key,$val) = each($value_y[$j]))
        $value_ysum[$key]+=$val;
    }    
    reset($value_ysum);
    $aprx=array();
    for ($i=0;($i<$vcnt_y)&&($vcnt_y>=5);$i++) {
      $aprx[$i]=get_aprx($i,$value_ysum,$vcnt_y);
    }
    if ($vcnt_y>=5) {
    $lp = new LinePlot($aprx);
    $lp->SetStyle('dashed'); 
    $lp->SetWeight(2);
    $lp->SetColor('black');
    $graph->Add($lp);
    }
    break;



#NON-ACCUMULATED FILLED LINE
  case 15:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
      $graph->Add($dplot[$i]);	
    }
    break;


#NON-ACCUMULATED LINE
  case 14:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
      $graph->Add($dplot[$i]);	
    }
    break;


#ACCUMULATED LINE + APR
  case 13:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
    }
    $accplot = new AccLinePlot($dplot);
    $graph->Add($accplot);

    $value_ysum=array();
    for ($j=0;$j<$cnt_y;$j++) {
      reset($value_y[$j]);
      while (list($key,$val) = each($value_y[$j]))
        $value_ysum[$key]+=$val;
    }    
    reset($value_ysum);
    for ($i=1;$i<$vcnt_y-1;$i++) {
      $key=key($value_ysum);
      $value_ysum[$key] = (current($value_ysum) + next($value_ysum)) /2;
    }
    $lp = new LinePlot($value_ysum);
    $lp->SetStyle('dashed');
    $lp->SetWeight(2);
    $lp->SetColor('black');
    $graph->Add($lp);
    break;


#ACCUMULATED FILLED LINE + APRX
  case 12:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
    }
    $accplot = new AccLinePlot($dplot);
    $graph->Add($accplot);
    
    $value_ysum=array();
    for ($j=0;$j<$cnt_y;$j++) {
      reset($value_y[$j]);
      while (list($key,$val) = each($value_y[$j]))
        $value_ysum[$key]+=$val;
    }    
    reset($value_ysum);
    $aprx=array();
    for ($i=0;($i<$vcnt_y)&&($vcnt_y>=5);$i++) {
      $aprx[$i]=get_aprx($i,$value_ysum,$vcnt_y);
    }
    if ($vcnt_y>=5) {
    $lp = new LinePlot($aprx);
    $lp->SetStyle('dashed'); 
    $lp->SetWeight(2);
    $lp->SetColor('black');
    $graph->Add($lp);
    }
    break;


#ACCUMULATED LINE
  case 11:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i])); 
    }
    $accplot = new AccLinePlot($dplot);
    $graph->Add($accplot);
    break;


#ACCUMULATED FILLED LINE 
  case 10:  
  default:
    for ($i=0; $i < $cnt_y; $i++) {
      $dplot[$i] = new LinePlot($value_y[$i]);
      $dplot[$i]->SetFillColor($color[$i % $colornum]);
      if ($legend_length)
        $dplot[$i]->SetLegend($legend_y[$i],"javascript:void(0)",x("Suma: ").number2human($value_ysum[$i]));
    }
    $accplot = new AccLinePlot($dplot);
    $graph->Add($accplot);
    break;
}




/* CAPACITY only for line & bar plots */
if ($capa && is_numeric($capa) && $capa>0 && $type<30) {
    $value_capa=array();
    for ($i=0;$i<count($value_x);$i++)
        $value_capa[]=$capa;
    $cp = new LinePlot($value_capa);
    $cp->SetStyle('dashed');
    $cp->SetWeight(3);
    $cp->SetColor('red');
    $graph->Add($cp);
    if ($dualy) {
      $value_capa2=array();
      for ($i=0;$i<count($value_x);$i++)
        $value_capa2[]=-$capa;
      $cp2 = new LinePlot($value_capa2);
      $cp2->SetStyle('dashed');
      $cp2->SetWeight(3);
      $cp2->SetColor('red');
      $graph->Add($cp2);
    }
}


/* ADD COMMENT */
if ($comment) {
  while ($graph->img->GetTextWidth($comment)+40 > $u_graph_x)
    $comment=substr($comment,0,strlen(comment)-1);
  $graph->footer->center->Set($comment); 
  $graph->footer->center->SetFont(FF_FONT1,FS_NORMAL);
  $graph->footer->center->SetColor("black");
  $graph->footer->center->SetBox('yellow','black',false,2,1); 
  $margin_y=75;
}


/* ADD COMPANY LOGO */
  if (isset($grpimg) && $grpimg) {
    if ($g_grpico_alpha<10 || $g_grpico_alpha>100)
      $g_grpico_alpha=30;
    $icon = new IconPlot("",0,0,1,$g_grpico_alpha);
    $icon->iImgString=$grpimg;

    $grpico_x=0;
    $grpico_y=0;
    if (isset($g_grpico_x) && is_numeric($g_grpico_x))
      $grpico_x=$g_grpico_x;
    if (isset($g_grpico_y) && is_numeric($g_grpico_y))
      $grpico_y=$g_grpico_y;

    if (($grpico_x<0)&&($grpico_y<0)) {
      $icon->SetAnchor('right','bottom');
      if ($grpico_x < -1)
	$grpico_x+=$u_graph_x;
      if ($grpico_y < -1)
	$grpico_y+=$u_graph_y;
    }
    elseif (($grpico_x<0)&&($grpico_y>=0)) {
      $icon->SetAnchor('right','top');
      if ($grpico_x < -1)
	$grpico_x+=$u_graph_x;
    }
    elseif (($grpico_x>=0)&&($grpico_y<0)) {
      $icon->SetAnchor('left','bottom');
      if ($grpico_y < -1)
	$grpico_y+=$u_graph_y;
    }

    $grpico_x=abs($grpico_x);
    $grpico_y=abs($grpico_y);

    $icon->SetPos($grpico_x,$grpico_y);

    $graph->Add($icon);
  }

/* ADD LEGEND MARGINS */

if ($legend_length) {
  $graph->img->SetMargin(60,50+$legend_length,25,$margin_y);
  $graph->legend->Pos(10/$u_graph_x,38/$u_graph_y,"right","top");
  $graph->legend->SetLineWeight(1);
  $graph->legend->SetShadow('darkgray',1);
}
else
  $graph->img->SetMargin(60,30,25,$margin_y);

if ($graph_aa)
  $graph->img->SetAntiAliasing();

/* CSIM support */
  if ($csim_mode) {
    echo $graph->GetHTMLImageMap('Map_'.$csim_mode);
    return;
  }

  return $graph->Stroke($handler);
}



/* *** FUNCTIONS *** */
 
 function scalehour($number) {
   return strftime("%H:%M",$number);
 }

 function scaleday($number) {
   return strftime("%H:%M",$number);
 }

 function scaleweek($number) {
   return strftime("%x",$number);
 }

 function scalemonth($number) {
   return strftime("%x",$number);
 }
 
 
 function clear_oldgraph() {
   $old_item=time()-86400; /* 1 day */
   $res=SQL_query("SELECT id FROM x_graph WHERE flag like 'cache' AND created<$old_item");
   if ($res) {
     while ($row=SQL_fetch_array($res)) {
       SQL_query("DELETE FROM x_graphd WHERE id_graph like '".$row[0]."'");
       SQL_query("DELETE FROM x_graph WHERE  id like '".$row[0]."'");
     }
     SQL_free_result($res);
   }
   SQL_query("OPTIMIZE TABLE x_graph, x_graphd");
 }
 
 function get_aprx($index,$arr,$num) {
   $cnt=0;
   $sum=0;
   if ($index==0) {
     $sum=(5*$arr[0])+(3*$arr[1])+(2*$arr[2]);
     $cnt=10;
   }
   elseif ($index==1) {
     $sum=(3*$arr[0])+(5*$arr[1])+(3*$arr[2])+(2*$arr[3]);
     $cnt=13;
   }
   elseif ($index==$num-1) {
     $sum=(2*$arr[$num-3])+(3*$arr[$num-2])+(5*$arr[$num-1]);
     $cnt=10;
   }
   elseif ($index==$num-2) {
     $sum=(2*$arr[$num-4])+(3*$arr[$num-3])+(5*$arr[$num-2])+(3*$arr[$num-1]);
     $cnt=13;
   }
   else {
     $sum=(2*$arr[$index-2])+(3*$arr[$index-1])+(5*$arr[$index])+(3*$arr[$index+1])+(2*$arr[$index+2]);
     $cnt=15;
   }
   return $sum/$cnt;
 }
 
?>