<?php

$no_session=1;

define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/constant.php');
require_once(PRG_PATH . 'core/config.php');
require_once(PRG_PATH . 'core/msgdlg.php');
require_once(PRG_PATH . 'core/global.php');
require_once(PRG_PATH . 'core/prgsession.php');

require_once(PRG_PATH . 'core/gettext.php');
require_once(PRG_PATH . 'core/option.php');
require_once(PRG_PATH . 'core/html.php');
require_once(PRG_PATH . 'core/database.php');
require_once(PRG_PATH . 'core/func.php');
require_once(PRG_PATH . 'core/menu.php');
require_once(PRG_PATH . 'core/specific.php');

require_once('slib.php');
require_once('utillib.php');

getGlobalVar('id',$id);
getGlobalVar('show',$show);
getGlobalVar('refresh',$refresh);


$handle=@opendir(PRG_EXPORTDIR);
if ($handle) {
  while ($file = readdir($handle)) {
    if (is_file(PRG_EXPORTDIR.$file)&&ereg("map[[:digit:]]+_([[:digit:]]+)",$file,$regs))
      if ($regs[1]+7200 < time()) /* 2 hours cache */
        unlink(PRG_EXPORTDIR.$file);
  }
  closedir($handle);
}

SQL_opendefault();
SQL_query("SET max_allowed_packet=16000000");



$map=load_background($id);
$objects=load_objects($id);
$paths=load_paths($id);

if (!$textclr)
  $textclr="black";

if ($refresh) {
  $res=SQL_query("SELECT id FROM x_utilmap WHERE enabled=1 ORDER by id");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      $id=$row[0];
      get_stat();
    }
    SQL_free_result($res);
  }
  die("All images refreshed ...");
}

if (!$show)
  get_stat();


$img=CreateImage($map,$objects,$paths);

if (!$show && $map_image)
  @imagegif($img,PRG_EXPORTDIR.$map_image);
show_image_exit($img);




/*  F U N C T I O N S */



function get_stat() {
  global $id,$id_c,$list_coll,$list_tables,$map,$objects,$paths,$map_image;

  $map_image="";
  $t=time();
  $minute=floor(($t%3600)/60);

  $list_tables=array();
  $list_coll=list_table("x_coll","ORDER BY name");
  load_util_tables();
  reset($list_tables);
  $src1_table=strftime("h".$id_c."_%y%m%d%H",$t);
  $src2_table=strftime("h".$id_c."_%y%m%d%H",$t-3600);

  if ($minute<5) {
    if (array_key_exists($src2_table,$list_tables)) {
      $src_table=$src2_table;
      $et_time=floor($t/3600)*3600;
      $st_time=$et_time-300;
      $et_time-=1;
      $map_image="map".$id."_".$st_time.".gif";
    }
  }
  else {
    if (array_key_exists($src1_table,$list_tables)) {
      $src_table=$src1_table;
      $et_time=floor($t/300)*300;
      $st_time=$et_time-300;
      $et_time-=1;
      $map_image="map".$id."_".$st_time.".gif";
    }
  }

  if ($map_image) {
    $map['showtimetext']=strftime("%x",$st_time)." ".strftime("%H:%M",$st_time)."-".strftime("%H:%M",$et_time+1);

    if (file_exists(PRG_EXPORTDIR.$map_image)) {
      $image_string=@file_get_contents(PRG_EXPORTDIR.$map_image);
      $img=imagecreatefromstring($image_string);
      show_image_exit($img);
    }


    $maplock=PRG_EXPORTDIR.PRG_SHORTNAME.'_lockmap_'.$id_c.'_'.$st_time;
    do {
      if(isset($hlock)) {
	flock($hlock,3);
	fclose($hlock);
      }
      $hlock=fopen($maplock,"w+");
      @flock($hlock,6,$lock_state);
    } while ($lock_state==1 && $hlock);


    $dst_table=get_dst_table($st_time);
    if ($dst_table=="") {
      $dst_table=SQL_escape("tmap_".$id_c."_".$st_time);
      SQL_query("DROP TABLE IF EXISTS $dst_table");
      if (SQL_query("CREATE TABLE ".$dst_table."_".$id." SELECT * FROM $src_table WHERE st BETWEEN '$st_time' AND '$et_time'")) {
	if (!SQL_query("RENAME TABLE ".$dst_table."_".$id." TO `".$dst_table."`") || get_dst_table($st_time)=="")
	  show_image_exit(ErrorImage(x("DBERROR: Can't rename table.")));
      }
      else
	show_image_exit(ErrorImage(x("DBERROR: Can't create temporary table."))); 
    }

    if ($hlock) {
      flock($hlock,3);
      fclose($hlock);
      @unlink($maplock);
    }

    reset($objects);
    while (list($key,$obj) = each($objects)) {
	$where="";
	$objects[$key]['text']=x("SQL ERROR");
	if ($obj['whr'])
	  $where="WHERE ".$obj['whr'];
	$res=SQL_query("SELECT sum(bytes) FROM $dst_table $where");
	if ($res) {
	  $row=SQL_fetch_array($res);
	  $bytes=$row[0];
	  SQL_free_result($res);
	  if ($obj['auto']) {
	    if ($bytes > $obj['capa']) {
	      $obj['capa']=$bytes;
	      SQL_query("UPDATE x_utilobj SET capacity='$bytes' WHERE id='$key'");
	    }
	  }
	  if ($obj['capa']==0)
	    $obj['capa']=($bytes)?$bytes:1;
	  $proc=round(($bytes/$obj['capa'])*100,1);
	  if ($proc>100)
	    $proc=100;
	  $objects[$key]['text']=number2human($bytes)." ".$proc."%";
	}
    }
  }
  else {
    reset($objects);
    while (list($key,$obj) = each($objects)) {
      $objects[$key]['text']=x("NO DATA");
    }
  }
}

function get_dst_table($st_time) {
  global $id_c;

  $list_ctables=array();
  $res=SQL_query("SHOW TABLES LIKE 'tmap%'");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      $list_ctables[]=$row[0];
    }
    SQL_free_result($res);
  }
  foreach($list_ctables as $ctable) {
    ereg("tmap_[[:digit:]]+_([[:digit:]]+)",$ctable,$regs);
    if (($regs[1]!=$st_time) && ($regs[1]!=$st_time-300))
      SQL_query("DROP TABLE IF EXISTS `".$ctable."`");
  }
  if (in_array("tmap_".$id_c."_".$st_time,$list_ctables))
    return "tmap_".$id_c."_".$st_time;
  return "";
}


function show_image_noexit($img) {
  global $imgtype;

  header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
  header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
  header ("Pragma: no-cache");                          // HTTP/1.0
  switch ($imgtype) {
    case "jpg":
	header("Content-type: image/jpeg");
	imagejpeg($img);
	break;
    case "png":
	header("Content-type: image/png");
	imagepng($img);
	break;
    default:    
	header("Content-type: image/gif");
	imagegif($img);
  }
  @SQL_close();
}

function show_image_exit($img) {
  show_image_noexit($img);
  die();
}


function load_util_tables() {
  global $id_c,$id;


  $res=SQL_query("SELECT id_coll FROM x_utilmap WHERE enabled=1 AND id='".SQL_escape($id)."'");
  if ($res) {
    $row=SQL_fetch_array($res);
    $id_c=$row[0];
    SQL_free_result($res);
    if ($id_c)
      get_table_select("h");
    else
      show_image_exit(ErrorImage(x("ERROR: Map ID don't exists or map is disabled.")));
  }
}


function load_background($id_map) {
  global $textclr,$pathclr,$imgtype;

  $map=array();
  $v=SQL_escape($id_map);
  $res=SQL_query("SELECT i.data,m.caption,m.id_coll,m.showcoll,m.showtime,m.textclr,m.pathclr,m.type FROM x_imagestore i,x_utilmap m WHERE m.id='$v' AND m.id_img=i.id");
  if ($res) {
    $row=SQL_fetch_array($res);
    $map['data']=base64_decode($row[0]);
    $map['caption']=$row[1];
    if ($row[3]) {
      $list_coll=list_table("x_coll");
      $map['showcoll']=$list_coll[$row[2]];
    }
    $map['showtime']=$row[4];
    $textclr=$row[5];
    $pathclr=$row[6];
    $imgtype=$row[7];
    SQL_free_result($res);
  }
  if ($imgtype!='jpg' && $imgtype!='png')
    $imgtype='gif';
  return $map;
}



function load_objects($id_map) {
  $objects=array();
  $v=SQL_escape($id_map);
  $res=SQL_query("SELECT o.id,i.data,o.map_x,o.map_y,o.caption,o.whr,o.capacity,o.capaauto FROM x_imagestore i,x_utilobj o WHERE o.id_map='$v' AND o.id_img=i.id");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      $objects[$row[0]]['data']=base64_decode($row[1]);
      $objects[$row[0]]['x']=$row[2];
      $objects[$row[0]]['y']=$row[3];
      $objects[$row[0]]['caption']=$row[4];
      $objects[$row[0]]['text']="POS: $row[2]x$row[3]";
      $objects[$row[0]]['whr']=$row[5];
      $objects[$row[0]]['capa']=$row[6];
      $objects[$row[0]]['auto']=$row[7];

    }
    SQL_free_result($res);
  }
  return $objects;
}



function load_paths($id_map) {
  $paths=array();
  $v=SQL_escape($id_map);
  $res=SQL_query("SELECT id_src,id_dst,type,weight FROM x_utilpth WHERE id_map='$v'");
  if ($res) {
    $i=0;
    while ($row=SQL_fetch_array($res)) {
	$paths[$i]['id_src']=$row[0];
	$paths[$i]['id_dst']=$row[1];
	$paths[$i]['type']=$row[2];
	$paths[$i]['weight']=$row[3];
        $i++;
    }
    SQL_free_result($res);
  }
  return $paths;
}



function imagelinethick($image,$x1,$y1,$x2,$y2,$color,$thick=1) {
  if ($thick==1)
    return imageline($image, $x1, $y1, $x2, $y2, $color);
 
  $t=$thick / 2 - 0.5;
  if ($x1==$x2 || $y1==$y2)
    return imagefilledrectangle($image,round(min($x1,$x2)-$t),round(min($y1,$y2)-$t),round(max($x1,$x2)+$t),round(max($y1,$y2)+$t),$color);
   $k=($y2-$y1) / ($x2-$x1); //y = kx + q
   $a=$t / sqrt(1+pow($k,2));
   $points = array(
       round($x1 - (1+$k)*$a), round($y1 + (1-$k)*$a),
       round($x1 - (1-$k)*$a), round($y1 - (1+$k)*$a),
       round($x2 + (1+$k)*$a), round($y2 - (1-$k)*$a),
       round($x2 + (1-$k)*$a), round($y2 + (1+$k)*$a),
   ); 
   imagefilledpolygon($image,$points,4,$color);
   return imagepolygon($image,$points,4,$color);
}



function AddImage($img,$object) {
  global $textclr,$img_colors;
  if (!$object['data'])
    return;
  $x=$object['x'];
  $y=$object['y'];
  $overlay_src = imagecreatefromstring($object['data']);
  $overlay_w = ImageSX($overlay_src);
  $overlay_h = ImageSY($overlay_src);

  $pict_x=($x>round($overlay_w/2))?($x-round($overlay_w/2)):0;
  $pict_y=($y>round($overlay_h/2))?($y-round($overlay_h/2)):0;

#Copy object into map and use transparent color FF00FF with little tolerance
  for ($x=0;$x<$overlay_w;$x++) {
    for ($y=0;$y<$overlay_h;$y++) {
      $rgba=imagecolorsforindex($overlay_src,imagecolorat($overlay_src, $x,$y));
      if ($rgba['red']<252 || $rgba['green']>3 || $rgba['blue']<252) {
	$color=imagecolorallocate($img,$rgba['red'],$rgba['green'],$rgba['blue']);
	imagesetpixel($img,$pict_x+$x,$pict_y+$y,$color);	
      }
    }
  }

  imagedestroy($overlay_src);    // no longer needed

  $color=imagecolorallocate($img,$img_colors[$textclr][0],$img_colors[$textclr][1],$img_colors[$textclr][2]);
  if ($object['caption']) {
    $caption=wordwrap($object['caption'],20,"\n");
    $caption=ereg_replace("~","\n",$caption);
    $captions=explode("\n",$caption);
    $fh=imagefontheight(IMG_FONT_TEXT);
    $cy=count($captions)*$fh;
    $cy=($cy>$pict_y)?0:($pict_y-$cy);
    foreach ($captions as $caption) {
      imagestring($img,IMG_FONT_TEXT,$pict_x,$cy,$caption,$color);
      $cy+=$fh;
    }
  }
  if ($object['text']) {
    $text=wordwrap($object['text'],20,"\n");
    $text=ereg_replace("~","\n",$text);
    $texts=explode("\n",$text);
    $fh=imagefontheight(IMG_FONT_TEXT);
    $cy=$pict_y+$overlay_h;
    foreach ($texts as $text) {
      imagestring($img,IMG_FONT_TEXT,$pict_x,$cy,$text,$color);
      $cy+=$fh;
    }
  }
}



function AddLine($img,$objects,$path) {
  global $pathclr,$img_colors;

  $src=$objects[$path['id_src']];
  $dst=$objects[$path['id_dst']];
  $color=imagecolorallocate($img,$img_colors[$pathclr][0],$img_colors[$pathclr][1],$img_colors[$pathclr][2]);
  if ($src['x'] && $src['y'] && $dst['x'] && $dst['y']) {
    $x1=$src['x'];
    $y1=$src['y'];
    $x2=$dst['x'];
    $y2=$dst['y'];
    imagelinethick($img,$x1,$y1,$x2,$y2,$color,$path['weight']);
  }
} 



function ErrorImage($text) {
  $w=(imagefontwidth(3)*strlen($text))+5;
  $h=imagefontheight(3)+5;
  $canvas_img = imagecreatetruecolor($w,$h);
  imagetruecolortopalette($canvas_img, false, 256); 
  $bc = imagecolorallocate ($canvas_img, 255, 255, 255);
  $fc = imagecolorallocate ($canvas_img, 0, 0, 0);
  imagefill($canvas_img,0,0,$bc);
  imagecolortransparent($canvas_img,$bc);
  imagestring($canvas_img,3,0,0,$text,$fc);
  return $canvas_img;
}



function CreateImage($map,$objects,$paths) {
  global $textclr,$img_colors,$imgtype;
  if ($map['data']) {
    $img_head_w=imagefontwidth(IMG_FONT_HEAD);
    $img_head_h=imagefontheight(IMG_FONT_HEAD);
    $img_tail_w=imagefontwidth(IMG_FONT_TAIL);
    $img_tail_h=imagefontheight(IMG_FONT_TAIL);

    $map_src = imagecreatefromstring($map['data']);
    $w = ImageSX($map_src);
    $h = ImageSY($map_src);
    $map_img = imagecreatetruecolor($w,$h);
    imagecopy($map_img,$map_src,0,0,0,0,$w,$h);
    imagedestroy($map_src);

    if ($imgtype=='gif') {
      #Allocate transparent color
      $transparent = imagecolorallocate($map_img,255,0,255);    
      imagecolortransparent($map_img, $transparent);
    }

    reset($paths);
    foreach ($paths as $path)
      AddLine($map_img,$objects,$path);
    reset($objects);
    foreach ($objects as $object)
      AddImage($map_img,$object);


    $img_w=$w;
    $img_h=$h;
    if ($map['caption'])
      $img_h+=$img_head_h;
    if ($map['showcoll'] || $map['showtime'])
      $img_h+=$img_tail_h;


    $img = imagecreatetruecolor($img_w,$img_h);
    if ($imgtype=='gif') {
      imagetruecolortopalette($img, false, 256); 
      $transparent = imagecolorallocate($img,255,0,255);
      imagecolortransparent($img, $transparent);
    }
    else
      $transparent = imagecolorallocate($img,255,255,255);

    $color=imagecolorallocate($img,$img_colors[$textclr][0],$img_colors[$textclr][1],$img_colors[$textclr][2]);
    imagefill($img,0,0,$transparent);

    if ($map['caption'])
      imagecopy($img,$map_img,0,$img_head_h,0,0,$w,$h);
    else
      imagecopy($img,$map_img,0,0,0,0,$w,$h);
    imagedestroy($map_img);



    if ($map['caption']) {
      $text=$map['caption'];
      $pos=round(($img_w-($img_head_w*strlen($text)))/2);
      imagestring($img,IMG_FONT_HEAD,$pos,0,$text,$color);
    }
    if ($map['showcoll']) {
      $text=x("Generated for collector:")." ".$map['showcoll'];
      imagestring($img,IMG_FONT_TAIL,0,$img_h-$img_tail_h,$text,$color);
    }
    if ($map['showtime']) {
      if ($map['showtimetext'])
        $text=$map['showtimetext'];
      else
        $text=strftime("%x %X",time());
      imagestring($img,IMG_FONT_TAIL,$img_w-($img_tail_w*strlen($text)),$img_h-$img_tail_h,$text,$color);
    }

    return $img;
  }
 
  $text=x("Error: cannot generate utilization map ...");
  return ErrorImage($text);
}

?>