<?php
define('HELPMARK','config_as.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('mapsubdelete',$mapsubdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('asn',$asn);
getGlobalVar('name',$name);
getGlobalVar('descr',$descr);
getGlobalVar('ip_s',$ip_s);
getGlobalVar('ip_e',$ip_e);

$descr=strip_lfcr($descr);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Autonomous System list"),'i_listas.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";
if ($mapsubdelete)
  $command="mapdelete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','map','mapadd','mapaddsubmit','mapdelete','mapdeletesubmit','mapedit','mapeditsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");
demo_cmd("mapaddsubmit");
demo_cmd("mapdeletesubmit");
demo_cmd("mapeditsubmit");


if ($command=="addsubmit") {
    $error="";
    $v=SQL_escape(array($asn,$name,$descr));
    var_number($error,'asn',x("AS number"),"",1,65535);
    if ($error) {
      $command="add";
    }
    elseif (!req_var($name,x("name")))
      $command="add";
    elseif (SQL_query("INSERT INTO x_as_p (asn,name,descr) 
	VALUES('$v[0]','$v[1]','$v[2]')")) {
      MsgInfo(x("AS name %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate item."));
      $command="add";
    }
}


if ($command=="editsubmit") {
    $error="";
    $v=SQL_escape(array($id,$asn,$name,$descr));
    var_number($error,'asn',x("AS number"),"",1,65535);
    if ($error) {
      $command="edit";
    }
    elseif (!req_var($name,x("name")))
      $command="edit";
    else
    if (SQL_query("UPDATE x_as_p SET asn='$v[1]',name='$v[2]',descr='$v[3]' WHERE id='$v[0]'")) {
      MsgInfo(x("AS name %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate item."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);

	$res=SQL_query("SELECT asn,name FROM x_as_p WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $asn=$row[0];
	  $name=$row[1];
          SQL_free_result($res);
        }

	if ($asn)
	  SQL_query("DELETE FROM x_ip_as_p WHERE asn='".SQL_escape($asn)."'");

        if (!SQL_query("DELETE FROM x_as_p WHERE id='$v'")) {
	    MsgError(x("Delete failed. AS name %s wasn't deleted."),$name);
	    $error=1;
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected AS names were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT asn,name,descr FROM x_as_p WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$asn=$row[0];
	$name=$row[1];
	$descr=$row[2];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new AS name"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit AS name"));
    }

    TItem(x("AS number:"));
    TItem(Input("asn",$asn,5));
    TNext();    
    TItem(x("AS name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("Description:"));
    TItem(InputText("descr",$descr));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected AS names?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,asn,name,descr FROM x_as_p");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("AS Number"));
      THItem(x("Name"));
      THItem(x("Description"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[1],'ALIGN="right"');
	TItem($row[2],'ALIGN="right"');
	TItem(str_strip($row[3]));
	TItem(ShowLink(x("Edit"),"as.php?command=edit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No autonomous system found ... Please, click on the 'Add' link in the left 'AS list' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}


if ($command=="mapaddsubmit") {
    $error="";
    
    $v=SQL_escape(array(ip2num($ip_s),ip2num($ip_e),$asn));
    var_ip($error,'ip_s',x("start IP address"));
    var_ip($error,'ip_e',x("end IP address"));
    var_number($error,'asn',x("AS number"),"",1,65535);
    if ($error) {
      $command="mapadd";
    }
    elseif (SQL_query("INSERT INTO x_ip_as_p (ipn_s,ipn_e,asn) 
	VALUES('$v[0]','$v[1]','$v[2]')")) {
      MsgInfo(x("AS mapping created successfully ..."));
      $command="map";
      history_save("ip_map",$ip_s);
      history_save("ip_map",$ip_e);
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate item."));
      $command="mapadd";
    }
}


if ($command=="mapeditsubmit") {
    $error="";
    $v=SQL_escape(array($id,ip2num($ip_s),ip2num($ip_e),$asn));
    var_ip($error,'ip_s',x("start IP address"));
    var_ip($error,'ip_e',x("end IP address"));
    var_number($error,'asn',x("AS number"),"",1,65535);
    if ($error) {
      $command="mapedit";
    }
    else
    if (SQL_query("UPDATE x_ip_as_p SET ipn_s='$v[1]',ipn_e='$v[2]',asn='$v[3]' WHERE id='$v[0]'")) {
      MsgInfo(x("AS map updated successfully ..."));
      $command="map";
      history_save("ip_map",$ip_s);
      history_save("ip_map",$ip_e);
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate item."));
      $command="mapedit";
    }
}



if ($command=="mapdeletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);

	$res=SQL_query("SELECT ipn_s,ipn_e,asn FROM x_ip_as_p WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $ip_s=num2ip($row[0]);
	  $ip_e=num2ip($row[1]);
	  $asn=$row[2];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_ip_as_p WHERE id='$v'")) {
	    MsgError(x("Delete failed. AS maping %s-%s AS%s wasn't deleted."),$ip_s,$ip_e,$asn);
	    $error=1;
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected AS maps were deleted ...")); 
  }
  $command="map";
}




if (($command=="mapadd")||($command=="mapedit")) {
    if (!$btn_save&&$command=="mapedit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT ipn_s,ipn_e,asn FROM x_ip_as_p WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$ip_s=num2ip($row[0]);
	$ip_e=num2ip($row[1]);
	$asn=$row[2];
        SQL_free_result($res);
      }
    }
    FormStart();
    popup_script("450","500",'','no');

    echo InputHidden("id",$id);
    if ($command=="mapadd") {
      echo InputHidden("command","mapaddsubmit");
      WinStart(x("Add new IP to AS map"));
    }  
    else {
      echo InputHidden("command","mapeditsubmit");
      WinStart(x("Edit IP to AS map"));
    }

    TItem(x("Start IP address:"));
    TItem(Input("ip_s",$ip_s,255).show_history("ip_map","ip_s"));
    TNext();
    TItem(x("End IP address:"));
    TItem(Input("ip_e",$ip_e,255).show_history("ip_map","ip_e"));
    TNext();
    TItem(x("AS number:"));
    TItem(Input("asn",$asn,5));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="mapdelete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","mapdeletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected AS maps?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="map";
}


if ($command=="map") {
  $res=SQL_query("SELECT id,ipn_s,ipn_e,asn FROM x_ip_as_p");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Start IP address"));
      THItem(x("End IP address"));
      THItem(x("AS Number"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem(num2ip($row[1]),'ALIGN="right"');
	TItem(num2ip($row[2]),'ALIGN="right"');
	TItem($row[3],'ALIGN="right"');
	TItem(ShowLink(x("Edit"),"as.php?command=mapedit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("mapsubdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No AS IP mapping found ... Please, click on the 'Add IP mapping' link in the left 'AS list' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}



MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'as.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'as.php?command=add');
  $mysubmenu[]=array('caption'=>x("IP mapping"),'url'=>'as.php?command=map');
  $mysubmenu[]=array('caption'=>x("Add IP mapping"),'url'=>'as.php?command=mapadd');
  MenuSub(x("AS list"),$mysubmenu);
}


?>