<?php
define('HELPMARK','config_host.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('ip',$ip);
getGlobalVar('descr',$descr);

$descr=strip_lfcr($descr);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Host list"),'i_listhost.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");


$name=strtolower($name);

if ($command=="addsubmit") {
    $error="";
    $v=SQL_escape(array($name,$ip,$descr));
    var_ip($error,'ip',x("IP address"));
    if ($error) {
      $command="add";
    }
    elseif (!req_var($name,x("name")))
      $command="add";
    else
    if (SQL_query("INSERT INTO x_hosts (name,ip,descr) 
	VALUES('$v[0]','$v[1]','$v[2]')")) {
      MsgInfo(x("Host assignment %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate item."));
      $command="add";
    }
}


if ($command=="editsubmit") {
    $error="";
    $v=SQL_escape(array($id,$name,$ip,$descr));
    var_ip($error,'ip',x("IP address"));
    if ($error) {
      $command="edit";
    }
    elseif (!req_var($name,x("name")))
      $command="edit";
    else
    if (SQL_query("UPDATE x_hosts SET name='$v[1]',ip='$v[2]',descr='$v[3]' WHERE id='$v[0]'")) {
      MsgInfo(x("Host assignment %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate item."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);

	$res=SQL_query("SELECT name FROM x_hosts WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_hosts WHERE id='$v'")) {
	    MsgError(x("Delete failed. Hosts assignment %s wasn't deleted."),$name);
	    $error=1;
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected host assignments were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,ip,descr FROM x_hosts WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$ip=$row[1];
	$descr=$row[2];
        SQL_free_result($res);
      }
    }
    FormStart();
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new host assignment"));
    }  
    else {
      echo InputHidden("id",$id);
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit host assignment"));
    }
        
    TItem(x("Host name:"));
    TItem(Input("name",$name,255));
    TNext();    
    TItem(x("IP address:"));
    TItem(Input("ip",$ip,15));
    TNext();
    TItem(x("Description:"));
    TItem(InputText("descr",$descr));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected host assignments?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,name,ip,descr FROM x_hosts");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("IP address"));
      THItem(x("Description"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[1]);
	TItem($row[2]);
	TItem(str_strip($row[3]));
	TItem(ShowLink(x("Edit"),"hosts.php?command=edit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="5" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No host found ... Please, click on the 'Add' link in the left 'Hosts' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'hosts.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'hosts.php?command=add');
  MenuSub(x("Hosts"),$mysubmenu);
}


?>