<?php
define('HELPMARK','config_networks.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('name',$name);
getGlobalVar('ip',$ip);
getGlobalVar('comment',$comment);

$comment=strip_lfcr($comment);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Network settings"),'i_network.gif');
RequireRights("options");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','ping');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");
demo_cmd("ping");

$name=strtolower($name);

if ($command=="addsubmit") {
    $v=SQL_escape(array($name,$ip,$comment));
    if (!req_var($name,x("name")))
      $command="add";
    else
    if (!req_var($ip,x("ip")))
      $command="add";
    else
    if (SQL_query("INSERT INTO x_network (name,ip,comment) 
	VALUES('$v[0]','$v[1]','$v[2]')")) {
      MsgInfo(x("Network %s created successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Insert failed. Maybe you tried inserting duplicate name."));
      $command="add";
    }
}


if ($command=="editsubmit") {
    $v=SQL_escape(array($id,$name,$ip,$comment));
    if (!req_var($name,x("name")))
      $command="edit";
    else
    if (!req_var($ip,x("ip")))
      $command="edit";
    else
    if (SQL_query("UPDATE x_network SET name='$v[1]',ip='$v[2]',comment='$v[3]' WHERE id='$v[0]'")) {
      MsgInfo(x("Network %s updated successfully ..."),$name);
      $command="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate name."));
      $command="edit";
    }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);
	SQL_query("LOCK TABLES x_network WRITE");

	$res=SQL_query("SELECT name FROM x_network WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

        if (!SQL_query("DELETE FROM x_network WHERE id='$v'")) {
	  MsgError(x("Delete failed. Network %s wasn't deleted."),$name);
	  $error=1;
	}
	
        SQL_query("UNLOCK TABLES");
      }
    }
    if (!$error)
      MsgInfo(x("Selected networks were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,ip,comment FROM x_network WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$ip=$row[1];
	$comment=$row[2];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new network"));
    }  
    else {
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit network"));
      TItem(x("Network ID:"));
      TItem("<B>$id</B>");
      TNext();
    }
        
    TItem(x("Network name:"));
    TItem(Input("name",$name,32));
    TNext();    
    TItem(x("IP address range:"));
    TItem(Input("ip",$ip,1024));
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected networks?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}


if ($command=="") {
  $res=SQL_query("SELECT id,name,comment FROM x_network");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Network ID"));
      THItem(x("Name"));
      THItem(x("Comment"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[0]);
	TItem($row[1]);
	TItem(str_strip($row[2]));
	TItem(ShowLink(x("Edit"),"networks.php?command=edit&id=$row[0]"),'ALIGN="center"');
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="5" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No network found ... Please, click on the 'Add' link in the left 'Networks' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'networks.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'networks.php?command=add');
  $mysubmenu[]=array('caption'=>x("Import"),'url'=>'networks_imp.php');
  MenuSub(x("Networks"),$mysubmenu);
}


?>