<?php

define('HELPMARK','status_database.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once('mysql_optimal.php');

PageHead();
PageLogo();
MenuStart('status','MySubMenu');
PageTitle(x("Database status - optimalization"),'i_database.gif');

RequireRights("status");


$sugs=get_mysql_suggest();

$critical=get_mysql_suggest_count($sugs,3,3);
$warnings=get_mysql_suggest_count($sugs,2,2);
$recommend=get_mysql_suggest_count($sugs,1,1);
$informal=get_mysql_suggest_count($sugs,0,0);

if ($critical || $warnings) {
  WinTStart();
  TItem(x("Critical problems:"));
  TItem('<b>'.$critical.'</b>');
  TLine();
  TItem(x("Warning problems:"));
  TItem('<b>'.$warnings.'</b>');
  TLine();
  TItem(x("Recommendations:"));
  TItem('<b>'.$recommend.'</b>');
  TLine();
  TItem(x("Informational:"));
  TItem('<b>'.$informal.'</b>');
  WinEnd();
  echo "<br/>\n";
}

if ($critical || $warnings || $recommend) {
  $myrest=' '.x("Don't forget to restart MySQL server after making changes. See documentation 'Chapter Optimizing and Tuning' for more details.");
  if (is_file('/etc/mysql/my.cnf') && (PRG_DBHOST=='' || PRG_DBHOST=='localhost'))
    MsgInfo(x("MySQL server configuration is stored in the <i>/etc/mysql/my.cnf</i> file.").$myrest);
  elseif (is_file('/etc/my.cnf') && (PRG_DBHOST=='' || PRG_DBHOST=='localhost'))
    MsgInfo(x("MySQL server configuration is stored in the <i>/etc/my.cnf</i> file.").$myrest);
  else
    MsgInfo(x("MySQL server configuration is usually stored in the <i>/etc/mysql/my.cnf</i> or <i>/etc/my.cnf</i> file.").$myrest);
}

$res=SQL_query("SHOW STATUS");
if ($res) {
  while ($row=SQL_fetch_row())
    if ($row[0]=='Uptime' && $row[1]<=3600)
      MsgInfo(x("MySQL started within last hour - recommendations may be inaccurate."));
  SQL_free_result($res);
}

if (is_array($sugs) && count($sugs)) {
  reset($sugs);
  for ($i=3; $i>=0; $i--) {
    switch ($i) {
      case 3: $parm=' colspan="2" style="background-color:#d00000; color:#000000;"'; break;
      case 2: $parm=' colspan="2" style="background-color:#ff8000; color:#000000;"'; break;
      case 1: $parm=' colspan="2" style="background-color:#0000ff; color:#ffffff;"'; break;
      case 0: $parm=' colspan="2" style="background-color:#008000; color:#ffffff;"'; break;
    }

    foreach ($sugs as $s) {
      if (is_array($s) && $s[0]==$i) { 
        WinTStart(' class="win_back" border="1" cellspacing="1" cellpadding="0" width="60%"');
        TItem('<b>'.$s[1].'</b>',$parm);
        TLine();
        TItem(x("Description:"),'align="left" valign="top" width="10%"');
        TItem($s[2]);
	if ($s[3]) {
          TLine();
          TItem(x("Solution:"),'align="left" valign="top" width="10%"');
          TItem($s[3]);
	}
        WinEnd();
	echo "<br/>\n";
      }
    }
  }
}



MenuEnd();
PageTail();

function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("Status"),'url'=>'database.php?command=status');
  $mysubmenu[]=array('caption'=>x("Processes"),'url'=>'database.php?command=process');
  $mysubmenu[]=array('caption'=>x("Tables"),'url'=>'database.php?command=table');
  $mysubmenu[]=array('caption'=>x("Variables"),'url'=>'database.php?command=variable');
  $mysubmenu[]=array('caption'=>x("Flush status"),'url'=>'database.php?command=flushs');
  $mysubmenu[]=array('caption'=>x("Flush tables"),'url'=>'database.php?command=flusht');
  $mysubmenu[]=array('caption'=>x("Optimalization"),'url'=>'mysqlopt.php');
  MenuSub(x("Database"),$mysubmenu);
}

?>
