<?php
define('HELPMARK','status_units.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);

getGlobalVar('id',$id);

PageHead();
PageLogo();
MenuStart('status');
PageTitle(x("Units status"),'i_unit.gif');
RequireRights("status");

check_command('detail');


if ($command=="detail") {
  $list_unit=list_table("x_unit","ORDER BY name");
  FormStart();
  echo InputHidden("command","detail");
  WinTStart();  
  TItem(x("Unit:").' '.InputSelect("id",select_list($list_unit,$id),($u_java)?"onchange=\"this.form.submit();\"":"").' '.
	    InputSubmit("send",x("Select")));
  WinEnd();
  FormEnd();

  if (!is_numeric($id))
    MsgFatal(x("Bad or unsupported ID"));

  $res=SQL_query("SELECT name FROM x_unit WHERE id='".SQL_escape($id)."'");
  if ($res) {
    if (($row=SQL_fetch_array($res)))
      $name=$row[0];
    SQL_free_result($res);
  }
    
  $stat=stat_getdetail("u$id");
  $r_stat=stat_getdetail("u$id",""," and access>=from_unixtime(unix_timestamp()-25)");
  if (count($stat)==0)
    MsgFatal(x("Unit never started !!!"));
  if (count($r_stat)==0)
    MsgWarn(x("Unit is NOT running at this moment..."));


  WinStart(x("Unit")." - ".$name);  
  THItem(x("Type"));
  THItem(x("Data on")." ".$stat[0][3]);
  
  $stat_gl=array();
  foreach ($stat as $row)
    $stat_gl[$row[1]]=$row;
  if (isset($stat_gl["pid"])) {
    TLine();
    TItem(x("Process ID (pid):"));
    TItem($stat_gl["pid"][2],'ALIGN="right"');
  }
  if (isset($stat_gl["load"])) {
    TLine();
    TItem(x("System load:"));
    TItem($stat_gl["load"][2],'ALIGN="right"');
  }
  if (isset($stat_gl["start"])) {
    TLine();
    TItem(x("Start time:"));
    TItem(strftime("%Y-%m-%d %X",$stat_gl["start"][2]),'ALIGN="right"');
    TLine();
    TItem(x("Uptime:"));
    TItem(get_uptime(time()-$stat_gl["start"][2]),'ALIGN="right"');
  }
  if (isset($stat_gl["udp_in"])) {
    TLine();
    TItem(x("UDP packets:"));
    TItem(show_value($stat_gl["udp_in"][2]),'ALIGN="right"');
  }
  if (isset($stat_gl["udp_noport"])) {
    TLine();
    TItem(x("UDP no port:"));
    TItem(show_value($stat_gl["udp_noport"][2]).show_error_perc($stat_gl["udp_in"][2],$stat_gl["udp_noport"][2]),'ALIGN="right"');
  }
  if (isset($stat_gl["udp_err"])) {
    TLine();
    TItem(x("UDP errors:"));
    TItem(show_value($stat_gl["udp_err"][2]).show_error_perc($stat_gl["udp_in"][2],$stat_gl["udp_err"][2]),'ALIGN="right"');
  }
  WinEnd();

  echo "<br/><br/>\n";

  $pstat=stat_getdetail("u$id\_%");
  if (count($pstat)) {
    WinStart(x("Sub Processes"));  
    THItem(x("Type"));
    THItem(x("ID/port"));
    THItem(x("Process ID (pid)"));
    THItem(x("Last echo at"));
  
    foreach ($pstat as $row) {
      if ($row[1]=="pid") {
        TLine();
        $type=ereg_replace("u$id.","",$row[0]);
        $stype=substr($type,0,1);
        $itype=substr($type,1);
        switch ($stype) {
          case "a":	TItem(x("Aggregation")); break;
          case "d":	TItem(x("Database")); break;
          case "w":	TItem(x("Worker")); break;
          case "n":	TItem(x("Network anomalies")); break;
	  default:	TItem(x("Unknown")." ($stype)"); break;
        }
        TItem($itype,'ALIGN="right"');
        TItem($row[2],'ALIGN="right"');
        TItem($row[3]);
      }
    }
    WinEnd();
    echo "<BR><BR>\n";
  }
  else
    MsgWarn(x("No running sub processes...")); 

  echo ShowLink(x("View collectors used by current unit"),"colls.php?unit=$id");
}


if ($command=="") {
  $res=SQL_query("SELECT id,name FROM x_unit ORDER BY name");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      WinTStart();
      THItem(x("State"));
      THItem(x("Name"));
      THItem(x("Command"));
      while (($row=SQL_fetch_array($res))) {
        $stat=stat_getdetail("u$row[0]","pid"," and access>from_unixtime(unix_timestamp()-25)");
	if ($stat[0][0])
	  $state=ShowImage(x("running"),PRG_PATH.'images/ic_gl.gif');
	else
	  $state=ShowImage(x("not running"),PRG_PATH.'images/ic_rl.gif');	
        TLine("","units.php?command=detail&id=$row[0]");
	TItem($state,'ALIGN="center"');
	TItem($row[1]);
	TItem(ShowLink(x("Detail"),"units.php?command=detail&id=$row[0]"),'ALIGN="center"');
      }
      WinEnd();
      FormEnd();
    }
    else
      MsgInfo(x("No units found ..."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();

function show_error_perc($valtotal=0,$valpart=0) {
  if (!$valtotal)
    return "&nbsp;0%";
  return '&nbsp;'.round($valpart/$valtotal * 100,1).'%';
}

?>